﻿using System;

namespace Verschluesseler
{
    public class Crypto
    {
        // wandelt lesbare Zeichen A..Z, a..z, 0..9, . und Leerzeichen in Zahl 0..63
        public int zeichen_zu_base64(char Zeichen) {
            if ((Zeichen >= 'A') && (Zeichen <= 'Z')) // 0..25 = 'A'..'Z'
                return Zeichen - 'A';
                
            if ((Zeichen >= 'a') && (Zeichen <= 'z')) // 26..51 = 'a'..'z'
                return Zeichen - 'a' + 26;

            if ((Zeichen >= '0') && (Zeichen <= '9')) // 52..61 = '0'..'9'
                return Zeichen - '0' + 52;

            if (Zeichen == '.')
                return 62;   

            return 63;  // jedes andere Zeichen   
        }
        
        // wandelt Zahl 0..63 zurück in lesbares Zeichen A..Z, a..z, 0..9, . und Leerzeichen
        public char base64_zu_zeichen(int Nummer) {
            if (Nummer < 26)   // 0..25 = 'A'..'Z'
                return (char) ( ( (int) 'A') + Nummer );
                
            if (Nummer < 52)   // 26..52 = 'a'..'z'
                return (char) ( ( (int) 'a') + Nummer - 26);

            if (Nummer < 62)   // 52..61 = '0'..'9'
                return (char) ( ( (int) '0' ) + Nummer - 52 );

            if (Nummer == 62)
                return '.';
                
            return ' ';        // Leerzeichen oder irgendein anderes Zeichen
        }
        
        // verschlüsselt ein einzelnes Zeichen
        public char verschluessle_zeichen(char Zeichen, char Schluessel) {
            
            // aktuelles Zeichen aus Text und Schlüssel in fortlaufende Nummer 0..37 wandeln
            int Zeichen_Nummer = zeichen_zu_base64(Zeichen);
            int Schluessel_Nummer = zeichen_zu_base64(Schluessel);
            
            // Addition mit Restklasse verschlüsselt ein einzelnes Zeichen
            int Verschluesselt_Nummer = (Zeichen_Nummer ^ Schluessel_Nummer);
            
            // Verschlüsselte Nummer zurück in lesbares Zeichen wandeln
            char Verschluesselt_Zeichen = base64_zu_zeichen(Verschluesselt_Nummer);

            //Console.WriteLine(Zeichen_Nummer + "^" + Schluessel_Nummer + "=" + Verschluesselt_Nummer);

            return Verschluesselt_Zeichen;
        }
    }
}

